(*/////////////////////////////////////////////////////////////////////////////
//
// Bossa, a framework for scheduler programming
// Copyright (C) 2005 Ecole des Mines de Nantes and
// Department of Computer Science, University of Copenhagen
//
// This file is part of Bossa.
//
// Bossa is free software; you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation; either version 2.1 of the License, or
// any later version.
//
// Bossa is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with Bossa; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// Please send remarks, questions and bug reports to bossa@emn.fr
// or to:
//
//   Gilles Muller
//   Ecole des Mines de Nantes,
//   La Chantrerie - 4, rue Alfred Kastler. B.P. 20722
//   44307 NANTES Cedex 3, FRANCE
//
///////////////////////////////////////////////////////////////////////////////
*)

type entry = Class_state.classname * Vobjects.vtype * Vobjects.modified
type intinfo = INT | UNINT (* interrupt permitted before event *)
type required = REQUIRED | OPTIONAL

val make_all_types :
    Ast.event_name list
    -> (Ast.event_name * entry list * entry list list) list
	-> (intinfo * Ast.event_name) Nfa2dfa.fa_state list
	  -> (intinfo * Ast.event_name) Nfa2dfa.fa_state list
	      -> ((Ast.event_name * (entry list) Model.sequence) list *
		    (Ast.event_name * intinfo * required)
		    Nfa2dfa.fa_state list *
		    (Ast.event_name * intinfo * required)
		    Nfa2dfa.fa_state list)

(* used to get the output configurations resulting from a given input
configuration *)
val get_outputs :
    bool (* only accept rule if src/tgt matches? *) ->
    entry list -> (Ast.event_name * entry list * entry list list) list ->
      Ast.event_name -> entry list list
