(*/////////////////////////////////////////////////////////////////////////////
//
// Bossa, a framework for scheduler programming
// Copyright (C) 2005 Ecole des Mines de Nantes and
// Department of Computer Science, University of Copenhagen
//
// This file is part of Bossa.
//
// Bossa is free software; you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation; either version 2.1 of the License, or
// any later version.
//
// Bossa is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with Bossa; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// Please send remarks, questions and bug reports to bossa@emn.fr
// or to:
//
//   Gilles Muller
//   Ecole des Mines de Nantes,
//   La Chantrerie - 4, rue Alfred Kastler. B.P. 20722
//   44307 NANTES Cedex 3, FRANCE
//
///////////////////////////////////////////////////////////////////////////////
*)

val pp_decl : bool -> Ast.vardecl -> unit
val pp_def : bool -> Ast.valdef -> unit
val pp_def_cs : bool -> Ast.valdef -> unit
val pp_stmt : Ast.stmt -> unit
val pp_for : Objects.identifier -> (unit -> unit) (* print stmt *) ->
 (* print stmt for a state represented as an array *)
  (Objects.identifier -> unit) ->
  bool -> Class_state.state_info list ->Ast.direction -> unit
val pp_exp : Ast.expr -> unit
val pp_seq : Ast.stmt -> unit
val pp_seq2 : Ast.stmt -> string -> unit
val pp_seq3 : Ast.stmt -> Objects.identifier -> Objects.identifier -> unit

type phase = HANDLERS | INTERFACE | INTERFACE_LABEL of string | ATTACH | DETACH
val current_phase : phase ref

val event_param : Objects.identifier ref
val move_possible : Ast.stmt -> bool

val list_of_const_val_enum : string list ref
