(*/////////////////////////////////////////////////////////////////////////////
//
// Bossa, a framework for scheduler programming
// Copyright (C) 2005 Ecole des Mines de Nantes and
// Department of Computer Science, University of Copenhagen
//
// This file is part of Bossa.
//
// Bossa is free software; you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation; either version 2.1 of the License, or
// any later version.
//
// Bossa is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with Bossa; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// Please send remarks, questions and bug reports to bossa@emn.fr
// or to:
//
//   Gilles Muller
//   Ecole des Mines de Nantes,
//   La Chantrerie - 4, rue Alfred Kastler. B.P. 20722
//   44307 NANTES Cedex 3, FRANCE
//
///////////////////////////////////////////////////////////////////////////////
*)

val policy_name : string ref
val external_functions : Objects.identifier list ref
val init_external_functions : unit -> unit
val print_nl_string : string -> unit
val print_between : (unit -> unit) -> ('a -> unit) -> 'a list -> unit
val is_struct : bool -> Objects.identifier -> bool
val pp_id : Objects.identifier -> unit
val is_state : Objects.identifier -> bool
val pp_ar_id : Objects.identifier -> unit
val pp_struct_id : Objects.identifier -> unit
val pp_struct_id2 : Objects.identifier -> unit
val pp_comma : unit -> unit
val pp_comma_nl : unit -> unit
val pp_semic : unit -> unit
val nl_ifnonempty : 'a list -> unit
val pp_arrayref_int : Objects.identifier -> int -> unit
val pp_arrayref_id : Objects.identifier -> Objects.identifier -> unit
val start_block : unit -> unit
val end_block : unit -> unit
val pp_arglist : bool-> string list -> unit
val pp_for_header :
    Objects.identifier -> Objects.identifier -> (unit -> unit) -> unit
val pp_for_header_deref :
    Objects.identifier -> Objects.identifier -> (unit -> unit) -> unit
val pp_state_cst : Objects.identifier -> unit
val check_simulate : (unit -> unit) -> (unit -> unit) -> unit
val process_state : (Objects.identifier -> unit)
  -> (Objects.identifier -> Objects.identifier -> unit)
    -> (Objects.identifier -> unit) -> (Objects.identifier -> unit)
      -> (Objects.identifier -> unit) -> Ast.state -> unit
val pp_bossa_struct : unit -> unit
val pp_bossa_struct_cs : unit -> string
val pp_scheduler_struct : unit -> unit
val pp_scheduler_struct_cs : unit -> string
val pp_type : Objects.typ -> unit
val pp_type_cs : Objects.typ -> string
val pp_etype : Objects.typ -> unit

val instance_variables : Objects.identifier list ref

(* C/C# compatability *)
val de_structify : string -> string
val mk_public : string -> unit
val mk_inline : unit -> unit
val mk_static : unit -> unit
val mk_static_private : unit -> unit
val mk_empty_prototype : unit -> unit
val mk_printk : string -> unit
val mk_attr : string -> string

