(*/////////////////////////////////////////////////////////////////////////////
//
// Bossa, a framework for scheduler programming
// Copyright (C) 2005 Ecole des Mines de Nantes and
// Department of Computer Science, University of Copenhagen
//
// This file is part of Bossa.
//
// Bossa is free software; you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation; either version 2.1 of the License, or
// any later version.
//
// Bossa is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with Bossa; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// Please send remarks, questions and bug reports to bossa@emn.fr
// or to:
//
//   Gilles Muller
//   Ecole des Mines de Nantes,
//   La Chantrerie - 4, rue Alfred Kastler. B.P. 20722
//   44307 NANTES Cedex 3, FRANCE
//
///////////////////////////////////////////////////////////////////////////////
*)

open Module_bossa_parser

(* ---------------------------- Keywords --------------------------- *)

let keyword_table = Hashtbl.create 53
let _ =
  List.iter (fun (kwd, tok) -> Hashtbl.add keyword_table kwd tok)
    [("scheduler", SCHEDULER);
      ("module", MODULE);
      ("virtual_scheduler_module", VSMODULE);
      ("modules", MODULES);
      ("requires", REQUIRES);
      ("reads", READS);
      ("next", NEXT);
      ("unshared", UNSHARED);
      ("global", GLOBAL);
      ("default", DEFAULT);
      ("high_res", HIGHRES);
      ("low_res", LOWRES);
      ("type", TYPE);
      ("enum", ENUM);
      ("system", SYSTEM);
      ("struct", STRUCT);
      ("process", PROCESS);
      ("const", CONST);
      ("admission", ADMIT);
      ("admission_criteria", ADMIT_CRIT);
      ("admission_attach", ADMIT_ATT);
      ("admission_detach", ADMIT_DET);
      ("ordering_criteria", ORDERING);
      ("lowest", LOWEST);
      ("highest", HIGHEST);
      ("key", KEY);
      ("trace", TRACE);
      ("events", EVENTS);
      ("test", TEST);
      ("expressions", EXPRESSIONS);
      ("states", STATES);
      ("equal", EQUAL);
      ("error", ERROR);
      ("READY", READY);
      ("RUNNING", RUNNING);
      ("BLOCKED", BLOCKED);
      ("TERMINATED", TERMINATED);
      ("NOWHERE", NOWHERE);
      ("queue", QUEUE);
      ("fifo", FIFO);
      ("lifo", LIFO);
      ("handler", HANDLER);
      ("event", EVENT);
      ("On", ON);
      ("overrideable", OVERRIDEABLE);
      ("forwardImmediate", FWD);
      ("virtual_scheduler", VIRTSCHEDULER);
      ("deferEvent", DEFER);
      ("srcOnSched", SRCONSCHED);
      ("schedulerOf", SCHEDULEROF);
      ("next", NEXT);
      ("public", PUBLIC);
      ("private", PRIVATE);
      ("interface", INTERFACE);
      ("transition", TRANSITION);
      ("Before", BEFORE);
      ("After", AFTER);
      ("select", SELECT);
      ("empty", EMPTY);
      ("int", INT);
      ("bool", BOOL);
      ("cycles", CYCLES);
      ("time", TIME);
      ("timer", TIMER);
      ("port", PORT);
      ("void", VOID);
      ("if", IF);
      ("else", ELSE);
      ("foreach", FOREACH);
      ("foreachIncreasing", FOREACHINC);
      ("foreachDecreasing", FOREACHDEC);
      ("break", BREAK);
      ("in", IN);
      ("switch", SWITCH);
      ("return", RETURN);
      ("case", CASE);
      ("true", TRUE);
      ("false", FALSE);
      ("head", HEAD);
      ("tail", TAIL)]
