(*/////////////////////////////////////////////////////////////////////////////
//
// Bossa, a framework for scheduler programming
// Copyright (C) 2005 Ecole des Mines de Nantes and
// Department of Computer Science, University of Copenhagen
//
// This file is part of Bossa.
//
// Bossa is free software; you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation; either version 2.1 of the License, or
// any later version.
//
// Bossa is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with Bossa; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// Please send remarks, questions and bug reports to bossa@emn.fr
// or to:
//
//   Gilles Muller
//   Ecole des Mines de Nantes,
//   La Chantrerie - 4, rue Alfred Kastler. B.P. 20722
//   44307 NANTES Cedex 3, FRANCE
//
///////////////////////////////////////////////////////////////////////////////
*)

type entry = Class_state.classname * Vobjects.vtype * Vobjects.modified
type event_class_type =
    Objects.isquasi *
      (entry list * Class_state.classname list) list *
      entry list list

val initial_event_specifications : unit -> Ast.event_name list
val system_event_specifications : unit -> Ast.event_name list
val application_event_specifications : unit -> Ast.event_name list
val top_level_events : unit -> Ast.event_name list list
val scheduler_events : unit -> Ast.event_name list list

val app_events_init_automaton :
    unit -> (int * Ast.event_name * Objects.intinfo * int) list
val app_events_automaton :
    unit -> (int * Ast.event_name * Objects.intinfo * int) list
val event_specifications :
    unit -> (Ast.event_name * event_class_type list) list
val vs_event_specifications :
    unit -> (Ast.event_name * event_class_type list) list
val interface_specifications :
    unit -> (Objects.identifier * event_class_type list) list
val vs_interface_specifications :
    unit -> (Objects.identifier * event_class_type list) list
